<?php

/**
 * co_etapa_modalidad actions.
 *
 * @package    contratacion
 * @subpackage co_etapa_modalidad
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_etapa_modalidadActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_ETAPA_MODALIDAD','CO_ETAPA','CO_MODALIDAD_SEL'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_MODALIDAD_SEL' =>
         array (
            'id_modalidad_sel' => 'CO_ETAPA_MODALIDAD'
         ),
        'CO_ETAPA'=>
        array(
            'id_etapa'=>'CO_ETAPA_MODALIDAD',
            
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_ETAPA_MODALIDAD' =>
       array(
            'id_etapa_modalidad' => 'id_etapa_modalidad',
            'id_etapa' => 'id_etapa',
            'id_modalidad_sel' => 'id_modalidad_sel',
            'orden' => 'orden',
            'estado' => 'estado'
        ),
        'CO_MODALIDAD_SEL'=>
        array(
            'prefijo' => 'prefijo_modalidad',
            'descripcion' => 'descripcion_modalidad'
        ),
        'CO_ETAPA'=>
        array(
            'descripcion' => 'descripcion_etapa',
            'aplica_tiempo' => 'aplica_tiempo',
            'aplica_numero' => 'aplica_numero',
            'aplica_desde_hasta' => 'aplica_desde_hasta',
            'aplica_oferentes' => 'aplica_oferentes',
            'aplica_adjudicatario' => 'aplica_adjudicatario'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_ETAPA_MODALIDAD' =>
        array(    
            'id_etapa_modalidad,a' => array('!=' => array(-1)),
            'id_etapa_modalidad,b' => array('=' => array('id_etapa_modalidad')),
            'id_etapa' => array('=' => array('id_etapa')),
            'id_modalidad_sel' => array('=' => array('id_modalidad_sel')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_MODALIDAD_SEL'=>
        array(
            'prefijo,a' => array('LIKEALLPLUS' => array('prefijo_modalidad', '%')),
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion_modalidad', '%'))
        ),
        'CO_ETAPA'=>
        array(
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion_etapa', '%')),
            'alerta' => array('=' => array('alerta'))
        )
        
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_etapa_modalidad'; //identificador de la tabla
    protected $id_names = array('id_etapa_modalidad'); //llave primaria
    protected $field_names = array('id_etapa', 'id_modalidad_sel', 'orden','estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_ETAPA_MODALIDAD'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_etapa_modalidad'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }    
}
